﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using ShoeStore.Entities;
using ShoeStore.Repositories;

namespace ShoeStore.Forms
{
    public partial class FormShoesReplenishment : Form
    {
        private readonly IShoesReplenishmentRepository _shoesReplenishmentRepository;
        public FormShoesReplenishment(IShoesReplenishmentRepository shoesReplenishmentRepository,
 IFactoryRepository factoryRepository,
        IShoesRepository shoesRepository)
        {
            InitializeComponent();
            _shoesReplenishmentRepository = shoesReplenishmentRepository ??
            throw new
            ArgumentNullException(nameof(shoesReplenishmentRepository));
            comboBoxFactory.DataSource =
            factoryRepository.ReadFactorys();
            comboBoxFactory.DisplayMember = "FirstName";
            comboBoxFactory.ValueMember = "Id";
            ColumnShoes.DataSource = shoesRepository.ReadShoess();
            ColumnShoes.DisplayMember = "Name";
            ColumnShoes.ValueMember = "Id";
        }
        private void ButtonSave_Click(object sender, EventArgs e)
        {
            try
            {
                if (dataGridViewShoess.RowCount < 1 || comboBoxFactory.SelectedIndex < 0)
                {
                    throw new Exception("Имеются незаполненные поля");
                }
                _shoesReplenishmentRepository.CreateShoesReplenishment(ShoesReplenishment.CreateOpeartion(0,
                (int)comboBoxFactory.SelectedValue!,
                CreateListShoesShoesReplenishmentsFromDataGrid()));
                Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при сохранении",
                MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        private void ButtonCancel_Click(object sender, EventArgs e) =>
        Close();
        private List<ShoesShoesReplenishment>
        CreateListShoesShoesReplenishmentsFromDataGrid()
        {
            var list = new List<ShoesShoesReplenishment>();
            foreach (DataGridViewRow row in dataGridViewShoess.Rows)
            {
                if (row.Cells["ColumnShoes"].Value == null ||
                row.Cells["ColumnCount"].Value == null)
                {
                    continue;
                }
                list.Add(ShoesShoesReplenishment.CreateElement(0,
                Convert.ToInt32(row.Cells["ColumnShoes"].Value),
                Convert.ToInt32(row.Cells["ColumnCount"].Value)));
            }
            return list;

        }
        private void dataGridViewShoess_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }
        private void FormShoesReplenishment_Load(object sender, EventArgs e)
        {

        }

       
    }
}
