﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using ShoeStore.Entities;
using ShoeStore.Repositories;

namespace ShoeStore.Forms
{
    public partial class FormShoesSale : Form
    {
        private readonly IShoesSaleRepository _shoesSaleRepository;
        public FormShoesSale(IShoesSaleRepository shoesSaleRepository, IShoesRepository shoesRepository, IFactoryRepository factoryRepository, IStoreRepository storeRepository)
        {
            InitializeComponent();
            _shoesSaleRepository = shoesSaleRepository ??
            throw new
            ArgumentNullException(nameof(shoesSaleRepository));
            comboBoxFactory.DataSource = factoryRepository.ReadFactorys();
            comboBoxFactory.DisplayMember = "FactoryName";
            comboBoxFactory.ValueMember = "Id";
            comboBoxShoes.DataSource = shoesRepository.ReadShoess();
            comboBoxShoes.DisplayMember = "Name";
            comboBoxShoes.ValueMember = "Id";
            comboBoxStore.DataSource = storeRepository.ReadStores();
            comboBoxStore.DisplayMember = "StoreName";
            comboBoxStore.ValueMember = "Id";
        }
        private void ButtonSave_Click(object sender, EventArgs e)
        {
            try
            {
                if (comboBoxShoes.SelectedIndex < 0 ||
                comboBoxFactory.SelectedIndex < 0 ||
                comboBoxStore.SelectedIndex < 0)
                {
                    throw new Exception("Имеются незаполненные поля");
                }
                _shoesSaleRepository.CreateShoesSale(ShoesSale.CreateOpeartion(
                0,
                (int)comboBoxShoes.SelectedValue!,
                (int)comboBoxFactory.SelectedValue!,
                (int)comboBoxStore.SelectedValue!,
                Convert.ToInt32(numericUpDownSpecificity.Value)));
                Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при сохранении",
                MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        private void ButtonCancel_Click(object sender, EventArgs e) =>
        Close();
        private void FormShoesSale_Load(object sender, EventArgs e)
        {

        }

       
    }
}

