﻿using ShoeStore.Repositories;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Unity;

namespace ShoeStore.Forms
{
    public partial class FormShoesSales : Form
    {
        private readonly IUnityContainer _container;
        private readonly IShoesSaleRepository _ShoesSaleRepository;
        public FormShoesSales(IUnityContainer container,
        IShoesSaleRepository ShoesSaleRepository)
        {
            InitializeComponent();
            _container = container ??
            throw new ArgumentNullException(nameof(container));
            _ShoesSaleRepository = ShoesSaleRepository ??
            throw new
            ArgumentNullException(nameof(ShoesSaleRepository));
        }
        private void FormShoesSales_Load(object sender, EventArgs e)
        {
            try
            {
                LoadList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при загрузке",
                MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        private void ButtonAdd_Click(object sender, EventArgs e)
        {
            try
            {
                _container.Resolve<FormShoesSale>().ShowDialog();
                LoadList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при добавлении", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        private void LoadList() => dataGridViewData.DataSource =
        _ShoesSaleRepository.ReadShoesSales();

        private void dataGridViewData_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        
    }
}
